#include <EXTRA.h>
#include <TextControl.h>
#include <ScrollView.h>
#include <StringView.h>
#include <String.h>
#include <CheckBox.h>
#include <SymLink.h>
#include <MenuField.h>
#include <PopUpMenu.h>
#include <MenuItem.h>
#include <Volume.h>
#include <VolumeRoster.h>
#include <NodeMonitor.h>

class FensterKlasse;

alQuickApp *prog;
alHandler *globalHandler;
FensterKlasse *MainWindow;
BFilePanel *openPanel;
BFilePanel *savePanel;
BVolumeRoster *globalVolumeList;

bool run = false;
int filecount;
bool copytimedate = false;

const int CONST_RUN    = 1;
const int CONST_SOURCE = 2;
const int CONST_TARGET = 3;
const int CONST_CopyControl = 4;
const int CONST_VOLUME = 8;

class FensterKlasse : public alQAWin
{
public:
BView *Background;
BTextControl *source;
BTextControl *target;
alLeftButton *startB;
alLeftButton *abortB;
alLeftButton *selectsource;
alLeftButton *selecttarget;
BStringView *statusview;
BStringView *statusview2;
BCheckBox *copyattr;
BMenuField *VolumeSelector;
BPopUpMenu *VolumePopUp;

FensterKlasse();
~FensterKlasse();
void UpdateVolumePopUp( void );
};



FensterKlasse::FensterKlasse():alQAWin(globalHandler, 300,300, "Virtual Archive")
{
Background = new BView ( BRect(0,0,300,300), "n" , B_FOLLOW_NONE , B_WILL_DRAW);
AddChild( Background );
rgb_color c;
c.red = 200;
c.green = 200;
c.blue = 200;

Background->SetViewColor(c);

startB = new alLeftButton( 10,270,130,25, "Run", new BMessage( CONST_RUN ));
abortB = new alLeftButton( 160,270,130,25, "Quit", new BMessage( B_QUIT_REQUESTED ));
selectsource = new alLeftButton ( 280,50,13,20, "?", new BMessage ( CONST_SOURCE ));
selecttarget = new alLeftButton ( 280,90,13,20, "?", new BMessage ( CONST_TARGET ));

Background->AddChild(startB);
Background->AddChild(abortB);
Background->AddChild(selectsource);
Background->AddChild(selecttarget);


VolumePopUp = new BPopUpMenu("VolumePop");
VolumePopUp->SetAsyncAutoDestruct(true);
VolumePopUp->AddItem( new BMenuItem("nothing", NULL));

VolumeSelector = new BMenuField( BRect(10,10,270,40), "Volumz", "Volumes:", VolumePopUp);
VolumeSelector->SetDivider(55);
Background->AddChild(VolumeSelector);

source = new BTextControl ( BRect(10,50,270,80), "source", "source:", "/boot", NULL);
source->SetDivider(55);
Background->AddChild(source);

target = new BTextControl ( BRect(10,90,270,120), "target", "target:", "/boot/Virtual", NULL);
target->SetDivider(55);
Background->AddChild(target);

statusview = new BStringView( BRect (10,130,290,150), "dir" , "no directory");
Background->AddChild(statusview);

statusview2 = new BStringView( BRect (10,160,290,180), "link" , "0 links installed");
Background->AddChild(statusview2);

copyattr = new BCheckBox ( BRect (10,240,290,260), "Copy attributes?", "target has time and date of source!", new BMessage( CONST_CopyControl ));
Background->AddChild(copyattr);
}



FensterKlasse::~FensterKlasse()
{
statusview->RemoveSelf();
delete statusview;

statusview2->RemoveSelf();
delete statusview2;


source->RemoveSelf();
delete source;

target->RemoveSelf();
delete target;

selectsource->RemoveSelf();
delete selectsource;

selecttarget->RemoveSelf();
delete selecttarget;

startB->RemoveSelf();
delete startB;

abortB->RemoveSelf();
delete abortB;

Background->RemoveSelf();
delete Background;
}


void FensterKlasse::UpdateVolumePopUp()
{
BVolume vol;
BMenuItem *x;

globalVolumeList->Rewind();
int i = VolumePopUp->CountItems();

for (int n = i-1; n >= 0; --n)
	{
	x = VolumePopUp->RemoveItem(n);
	delete x;
	}

i = VolumePopUp->CountItems();
		
while ( globalVolumeList->GetNextVolume(&vol) == B_OK )
		{
		BMessage *nachricht;
		char *Name;
		alDirectory	dir;
			
		if (vol.IsPersistent())
			{
			vol.GetRootDirectory( (BDirectory *) &dir );
			Name = dir.FullPath();
			nachricht = new BMessage(CONST_VOLUME);
			nachricht->AddString("name",Name);
			VolumePopUp->AddItem(new BMenuItem(Name, nachricht));
			delete Name;
			}
		}
		
}


class Engine
{
public:
alDirectory *myDir;
alDirectory *copytoDir;

Engine( const char *res, const char *aim);
~Engine();
void Run(bool master = false);
};


Engine::Engine( const char *res, const char *aim)
{
myDir = new alDirectory( res );
copytoDir = new alDirectory ( aim );
myDir->Rewind();
}

Engine::~Engine()
{
delete myDir;
delete copytoDir;
}

void Engine::Run(bool master)
{
status_t result = B_OK;
alEntry foundEntry;
char *text, *text2, *name;
alDirectory newtargetDIR;

copytoDir->GetEntry ((BEntry *) &foundEntry );
if (foundEntry.Exists() == false) return;

myDir->GetEntry ((BEntry *) &foundEntry );
if (foundEntry.Exists() == false) return;

text = myDir->FullPath();
copytoDir->CreateSymLink("this_dir", text, NULL);
delete text;

if (!run) return;

do
	{
	result = myDir->GetNextEntry( &foundEntry );
	
	if (result == B_OK)
		{
		
		if (foundEntry.IsDirectory())
			{ //If it is a Directory then create a similar directoy at target and create a subengine
			text = foundEntry.Name();			
			copytoDir->CreateDirectory(text, (BDirectory *) &newtargetDIR);
			delete [] text;
			
			text = foundEntry.FullPath();
			text2 = newtargetDIR.FullPath();			

			newtargetDIR.CreateSymLink("this_dir",text, NULL);
			
			if (copytimedate)
				{
				status_t res;
				time_t ctime;
				res = foundEntry.GetCreationTime( &ctime );
				res = newtargetDIR.SetCreationTime( ctime );

				switch (res)
					{
					case B_NOT_ALLOWED: {extra::OKBox("Dir: B_NOT_ALLOWED"); break; }
					case B_NO_MEMORY: {extra::OKBox("Dir: B_NO_MEMORY"); break; }
					case B_BAD_VALUE: {extra::OKBox("Dir: B_BAD_VALUE"); break; }
					}
				}
			
			Engine sub (text, text2);
			sub.Run();
			
			MainWindow->Lock();
			MainWindow->statusview->SetText( text );
			MainWindow->Unlock();
			
			delete [] text;
			delete [] text2;
			}
		else
			{ //create a link to this whatsoever entry
			text = foundEntry.FullPath();
			name = foundEntry.Name(false);
			BSymLink Link;			
			
			copytoDir->CreateSymLink( name , text, &Link);
			++filecount;
			
			if (copytimedate)
				{
				status_t res;
				time_t ctime;
				res = foundEntry.GetCreationTime( &ctime );
				res = Link.SetCreationTime( ctime );
				
				switch (res)
					{
					case B_NOT_ALLOWED: {extra::OKBox("Link: B_NOT_ALLOWED"); break; }
					case B_NO_MEMORY: {extra::OKBox("Link: B_NO_MEMORY"); break; }
					case B_BAD_VALUE: {extra::OKBox("Link: B_BAD_VALUE"); break; }
					}
				}

			
			BString a( extra::StringOutOf(filecount) );
			a.Append(" links installed; ");
			a.Append( text );
			
			MainWindow->Lock();
			MainWindow->statusview2->SetText( a.String() );
			MainWindow->Unlock();
			
			delete [] text;
			}
		}
	}
while ((result == B_OK) && (run));
if (master)
	{
	MainWindow->Lock();
	MainWindow->abortB->Show();
	MainWindow->startB->SetLabel("Run");
	MainWindow->Unlock();
	run = false;
	}
}



int32 CoreFunction(void *s)
{
Engine master( MainWindow->source->Text(), MainWindow->target->Text() );
filecount = 0;

master.Run(true); //true = this is a master call

alThread *x = (alThread *) s;
delete x;
return 0;	
}


void MessageReceived1( BMessage *message, alHandler *thisone)
{
int32 op;
status_t res;
res = message->FindInt32( "opcode" , &op);

if (res == B_OK)
	{
	if ((op == B_DEVICE_MOUNTED) || (op == B_DEVICE_UNMOUNTED))
		{
		MainWindow->UpdateVolumePopUp();
		}
	}

switch (message->what)
	{
	case CONST_AppReadyToRun:
		{
		FensterKlasse *win;
		win = new FensterKlasse();
		prog->AppMainFrame = (alQAWin *) win;
		win->SetLook( B_TITLED_WINDOW_LOOK );
		win->SetFlags ( B_NOT_RESIZABLE );
		win->Show();
		
		MainWindow = win;
		
		BMessage proto1;
		proto1.AddInt32("paneltype",1);
		proto1.what = 5;
		
		openPanel = extra::GetFilePanel(false, true);
		openPanel->SetMessage(&proto1);

		
		BMessage proto2;
		proto2.AddInt32("paneltype",2);
		proto2.what = 5;
		
		savePanel = extra::GetFilePanel(false, true);
		savePanel->SetMessage(&proto2);
		
		globalVolumeList = new BVolumeRoster();
		
		MainWindow->UpdateVolumePopUp();
		globalVolumeList->StartWatching();
		break;
		}
	case CONST_ESC:
	case CONST_MainFrameQuits:
		{
		prog->PostMessage( B_QUIT_REQUESTED );
		break;
		}
	case CONST_SOURCE:
		{
		openPanel->Show();
		break;
		}
	case CONST_TARGET:
		{
		savePanel->Show();
		break;
		}
	case 5:
		{
		entry_ref r;
		int32 which;
		message->FindRef("refs", &r);
		message->FindInt32("paneltype",&which);
		
		BEntry Eintrag (&r);
		BPath Pfad;
		Eintrag.GetPath(&Pfad);
		
		MainWindow->Lock();
		if (which == 1) MainWindow->source->SetText(Pfad.Path());
		if (which == 2) MainWindow->target->SetText(Pfad.Path());
		MainWindow->Unlock();
		
		break;
		}
	case CONST_RUN:
		{
		MainWindow->Lock();
		if (!run) 
			{
			run = true;
			MainWindow->startB->SetLabel("Abort");
			new alThread( &CoreFunction , "Archive creating thread" , true);
			MainWindow->abortB->Hide();
			}
		else 
			{
			run = false;
			MainWindow->startB->SetLabel("Run");
			MainWindow->abortB->Show();
			}
		MainWindow->Unlock();
		break;
		}
	case CONST_CopyControl:
		{
		if (copytimedate) copytimedate = false; else copytimedate = true;
		break;
		}
	case CONST_VOLUME:
		{
		const char *text;
		message->FindString("name",&text);
		MainWindow->source->SetText( text );
		break;
		}
	}
}

int main()
{
globalHandler = new alHandler ( *MessageReceived1, "The only handler in this app" );
prog = new alQuickApp( globalHandler, "Application/VirtualArchive" );
prog->Run();
delete globalVolumeList;
}